library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity checksum is
	port (
		srst	:	in	std_logic;
		clk		:	in	std_logic;
		
		d		:	in	std_logic_vector(7 downto 0);
		d_valid	:	in	std_logic;
		
		q		:	out	std_logic_vector(7 downto 0);
		q_valid	:	out	std_logic
	);
end checksum;
	
architecture RTL of checksum is
	
	signal	sum	:	std_logic_vector(7 downto 0);
	
begin
	
	q	<=	sum;
	
	process(clk)
	begin
		if rising_edge(clk) then
			if (srst = '1') then
				sum	<=	(others => '0');
			else
				if (d_valid = '1') then
					sum	<=	sum + d;
				end if;
			end if;
		end if;
	end process;
	
	process(clk)
	begin
		if rising_edge(clk) then
			if (srst = '1') then
				q_valid	<=	'0';
			else
				if (d_valid = '1') then
					q_valid	<=	'1';
				else
					q_valid	<=	'0';
				end if;
			end if;
		end if;
	end process;
	
	
end RTL;
