library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity comm_clken is
		generic (
			CNTMAX	:	std_logic_vector(8 downto 0) := conv_std_logic_vector(43,9)
		);
		port	(
			srst	:	in	std_logic;
			clk		:	in	std_logic;
			en		:	out	std_logic
		);
end comm_clken;
	
	
architecture RTL of comm_clken is
	
	signal	cnt	:	std_logic_vector(8 downto 0);

begin
	
	process(clk)
	begin
		if rising_edge(clk) then
			if (srst = '1') then
				cnt	<=	(others => '0');
				en	<=	'0';
			else
				if (cnt = CNTMAX) then
					cnt	<=	(others => '0');
					en	<=	'1';
				else
					cnt	<=	cnt + '1';
					en	<=	'0';
				end if;
			end if;
		end if;
	end process;
	
end RTL;
