library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
--use IEEE.numeric_std.all;
--use STD.textio.all;

library std;
use std.env.all;

entity tb_comm_tx_mult is
end tb_comm_tx_mult;

architecture sim of tb_comm_tx_mult is
	
	constant	ZERO	:	std_logic_vector(31 downto 0)	:=	(others => '0');
	constant	ONE		:	std_logic_vector(31 downto 0)	:=	(others => '1');
	constant	UNKNOWN	:	std_logic_vector(31 downto 0)	:=	(others => 'X');
	
	component comm_tx_mult
		generic (
			COMM_TX_SPEED	:	std_logic_vector(8 downto 0) := conv_std_logic_vector(434,9); -- 50,000,000Hz / 115,200bps * 1 = 434.0278  434:115,207.37bps
			CHECKSUM_ENABLE	:	boolean	:=	FALSE
		);
		port (
			srst	:	in	std_logic;
			clk		:	in	std_logic;
			
			start	:	in	std_logic;
			busy	:	out	std_logic;
			pdatmax	:	in	std_logic_vector(4 downto 0);
			
			pdat00	:	in	std_logic_vector(7 downto 0);
			pdat01	:	in	std_logic_vector(7 downto 0);
			pdat02	:	in	std_logic_vector(7 downto 0);
			pdat03	:	in	std_logic_vector(7 downto 0);
			pdat04	:	in	std_logic_vector(7 downto 0);
			pdat05	:	in	std_logic_vector(7 downto 0);
			pdat06	:	in	std_logic_vector(7 downto 0);
			pdat07	:	in	std_logic_vector(7 downto 0);
			pdat08	:	in	std_logic_vector(7 downto 0);
			pdat09	:	in	std_logic_vector(7 downto 0);
			pdat10	:	in	std_logic_vector(7 downto 0);
			pdat11	:	in	std_logic_vector(7 downto 0);
			pdat12	:	in	std_logic_vector(7 downto 0);
			pdat13	:	in	std_logic_vector(7 downto 0);
			pdat14	:	in	std_logic_vector(7 downto 0);
			pdat15	:	in	std_logic_vector(7 downto 0);
			pdat16	:	in	std_logic_vector(7 downto 0);
			pdat17	:	in	std_logic_vector(7 downto 0);
			pdat18	:	in	std_logic_vector(7 downto 0);
			pdat19	:	in	std_logic_vector(7 downto 0);
			pdat20	:	in	std_logic_vector(7 downto 0);
			pdat21	:	in	std_logic_vector(7 downto 0);
			pdat22	:	in	std_logic_vector(7 downto 0);
			pdat23	:	in	std_logic_vector(7 downto 0);
			pdat24	:	in	std_logic_vector(7 downto 0);
			pdat25	:	in	std_logic_vector(7 downto 0);
			pdat26	:	in	std_logic_vector(7 downto 0);
			pdat27	:	in	std_logic_vector(7 downto 0);
			pdat28	:	in	std_logic_vector(7 downto 0);
			pdat29	:	in	std_logic_vector(7 downto 0);
			pdat30	:	in	std_logic_vector(7 downto 0);
			pdat31	:	in	std_logic_vector(7 downto 0);
			
			sdat	:	out	std_logic
		);
	end component comm_tx_mult;
	
	component comm_rx_mult is
		generic (
			COMM_RX_SPEED		:	std_logic_vector(8 downto 0) := conv_std_logic_vector(434,9); -- 50,000,000Hz / 115,200bps * 1 = 434.0278  434:115,207.37bps
			COMM_RX_SPEED_HALF	:	std_logic_vector(8 downto 0) := conv_std_logic_vector(217,9) -- 50,000,000Hz / 115,200bps / 2 = 217.0138  217:115,207.37bps
		);
		port (
			srst	:	in	std_logic;
			clk		:	in	std_logic;
			
			busy	:	out	std_logic;
			pdatmax	:	in	std_logic_vector(4 downto 0);
			
			sdat	:	in	std_logic;
			
			pdat_parity_error	:	out	std_logic;
			pdat_chksum_error	:	out	std_logic;
			pdat_valid			:	out	std_logic;
			
			pdat_chksum			:	out	std_logic_vector(7 downto 0);
			pdat00				:	out	std_logic_vector(7 downto 0);
			pdat01				:	out	std_logic_vector(7 downto 0);
			pdat02				:	out	std_logic_vector(7 downto 0);
			pdat03				:	out	std_logic_vector(7 downto 0);
			pdat04				:	out	std_logic_vector(7 downto 0);
			pdat05				:	out	std_logic_vector(7 downto 0);
			pdat06				:	out	std_logic_vector(7 downto 0);
			pdat07				:	out	std_logic_vector(7 downto 0);
			pdat08				:	out	std_logic_vector(7 downto 0);
			pdat09				:	out	std_logic_vector(7 downto 0);
			pdat10				:	out	std_logic_vector(7 downto 0);
			pdat11				:	out	std_logic_vector(7 downto 0);
			pdat12				:	out	std_logic_vector(7 downto 0);
			pdat13				:	out	std_logic_vector(7 downto 0);
			pdat14				:	out	std_logic_vector(7 downto 0);
			pdat15				:	out	std_logic_vector(7 downto 0);
			pdat16				:	out	std_logic_vector(7 downto 0);
			pdat17				:	out	std_logic_vector(7 downto 0);
			pdat18				:	out	std_logic_vector(7 downto 0);
			pdat19				:	out	std_logic_vector(7 downto 0);
			pdat20				:	out	std_logic_vector(7 downto 0);
			pdat21				:	out	std_logic_vector(7 downto 0);
			pdat22				:	out	std_logic_vector(7 downto 0);
			pdat23				:	out	std_logic_vector(7 downto 0);
			pdat24				:	out	std_logic_vector(7 downto 0);
			pdat25				:	out	std_logic_vector(7 downto 0);
			pdat26				:	out	std_logic_vector(7 downto 0);
			pdat27				:	out	std_logic_vector(7 downto 0);
			pdat28				:	out	std_logic_vector(7 downto 0);
			pdat29				:	out	std_logic_vector(7 downto 0);
			pdat30				:	out	std_logic_vector(7 downto 0);
			pdat31				:	out	std_logic_vector(7 downto 0)
		);
	end component comm_rx_mult;
	
	signal	clk			:	std_logic;
	signal	srst		:	std_logic;
	
	signal	start		:	std_logic := '0';
	signal	busy		:	std_logic;
	signal	pdatmax		:	std_logic_vector(4 downto 0) := conv_std_logic_vector(15,5);
	
	signal	pdat00		:	std_logic_vector(7 downto 0) := X"90";
	signal	pdat01		:	std_logic_vector(7 downto 0) := X"91";
	signal	pdat02		:	std_logic_vector(7 downto 0) := X"92";
	signal	pdat03		:	std_logic_vector(7 downto 0) := X"93";
	signal	pdat04		:	std_logic_vector(7 downto 0) := X"94";
	signal	pdat05		:	std_logic_vector(7 downto 0) := X"95";
	signal	pdat06		:	std_logic_vector(7 downto 0) := X"96";
	signal	pdat07		:	std_logic_vector(7 downto 0) := X"97";
	signal	pdat08		:	std_logic_vector(7 downto 0) := X"98";
	signal	pdat09		:	std_logic_vector(7 downto 0) := X"99";
	signal	pdat10		:	std_logic_vector(7 downto 0) := X"9A";
	signal	pdat11		:	std_logic_vector(7 downto 0) := X"9B";
	signal	pdat12		:	std_logic_vector(7 downto 0) := X"9C";
	signal	pdat13		:	std_logic_vector(7 downto 0) := X"9D";
	signal	pdat14		:	std_logic_vector(7 downto 0) := X"9E";
	signal	pdat15		:	std_logic_vector(7 downto 0) := X"9F";
		
	signal	sdat		:	std_logic;
	
	signal	rx_busy					:	std_logic;
	signal	rx_pdat_parity_error	:	std_logic;
	signal	rx_pdat_chksum_error	:	std_logic;
	signal	rx_pdat_valid			:	std_logic;
	
	signal	rx_pdat_chksum			:	std_logic_vector(7 downto 0);
	signal	rx_pdat00				:	std_logic_vector(7 downto 0);
	signal	rx_pdat01				:	std_logic_vector(7 downto 0);
	signal	rx_pdat02				:	std_logic_vector(7 downto 0);
	signal	rx_pdat03				:	std_logic_vector(7 downto 0);
	signal	rx_pdat04				:	std_logic_vector(7 downto 0);
	signal	rx_pdat05				:	std_logic_vector(7 downto 0);
	signal	rx_pdat06				:	std_logic_vector(7 downto 0);
	signal	rx_pdat07				:	std_logic_vector(7 downto 0);
	signal	rx_pdat08				:	std_logic_vector(7 downto 0);
	signal	rx_pdat09				:	std_logic_vector(7 downto 0);
	signal	rx_pdat10				:	std_logic_vector(7 downto 0);
	signal	rx_pdat11				:	std_logic_vector(7 downto 0);
	signal	rx_pdat12				:	std_logic_vector(7 downto 0);
	signal	rx_pdat13				:	std_logic_vector(7 downto 0);
	signal	rx_pdat14				:	std_logic_vector(7 downto 0);
	signal	rx_pdat15				:	std_logic_vector(7 downto 0);
	signal	rx_pdat16				:	std_logic_vector(7 downto 0);
	signal	rx_pdat17				:	std_logic_vector(7 downto 0);
	signal	rx_pdat18				:	std_logic_vector(7 downto 0);
	signal	rx_pdat19				:	std_logic_vector(7 downto 0);
	signal	rx_pdat20				:	std_logic_vector(7 downto 0);
	signal	rx_pdat21				:	std_logic_vector(7 downto 0);
	signal	rx_pdat22				:	std_logic_vector(7 downto 0);
	signal	rx_pdat23				:	std_logic_vector(7 downto 0);
	signal	rx_pdat24				:	std_logic_vector(7 downto 0);
	signal	rx_pdat25				:	std_logic_vector(7 downto 0);
	signal	rx_pdat26				:	std_logic_vector(7 downto 0);
	signal	rx_pdat27				:	std_logic_vector(7 downto 0);
	signal	rx_pdat28				:	std_logic_vector(7 downto 0);
	signal	rx_pdat29				:	std_logic_vector(7 downto 0);
	signal	rx_pdat30				:	std_logic_vector(7 downto 0);
	signal	rx_pdat31				:	std_logic_vector(7 downto 0);
	
	
begin
	
	uut_tx: comm_tx_mult
		generic map (
			COMM_TX_SPEED		=>	conv_std_logic_vector(434,9), -- 50,000,000Hz / 115,200bps * 1 = 434.0278  434:115,207.37bps
			CHECKSUM_ENABLE		=>	TRUE
		)
		port map (
			srst				=>	srst,
			clk					=>	clk,
			
			start				=>	start,
			busy				=>	busy,
			pdatmax				=>	pdatmax,
			
			pdat00				=>	pdat00,
			pdat01				=>	pdat01,
			pdat02				=>	pdat02,
			pdat03				=>	pdat03,
			pdat04				=>	pdat04,
			pdat05				=>	pdat05,
			pdat06				=>	pdat06,
			pdat07				=>	pdat07,
			pdat08				=>	pdat08,
			pdat09				=>	pdat09,
			pdat10				=>	pdat10,
			pdat11				=>	pdat11,
			pdat12				=>	pdat12,
			pdat13				=>	pdat13,
			pdat14				=>	pdat14,
			pdat15				=>	pdat15,
			pdat16				=>	UNKNOWN(7 downto 0),
			pdat17				=>	UNKNOWN(7 downto 0),
			pdat18				=>	UNKNOWN(7 downto 0),
			pdat19				=>	UNKNOWN(7 downto 0),
			pdat20				=>	UNKNOWN(7 downto 0),
			pdat21				=>	UNKNOWN(7 downto 0),
			pdat22				=>	UNKNOWN(7 downto 0),
			pdat23				=>	UNKNOWN(7 downto 0),
			pdat24				=>	UNKNOWN(7 downto 0),
			pdat25				=>	UNKNOWN(7 downto 0),
			pdat26				=>	UNKNOWN(7 downto 0),
			pdat27				=>	UNKNOWN(7 downto 0),
			pdat28				=>	UNKNOWN(7 downto 0),
			pdat29				=>	UNKNOWN(7 downto 0),
			pdat30				=>	UNKNOWN(7 downto 0),
			pdat31				=>	UNKNOWN(7 downto 0),
			
			sdat				=>	sdat
		);
	
	uut_rx: comm_rx_mult
		generic map(
			COMM_RX_SPEED		=>	conv_std_logic_vector(434,9),	-- 50,000,000Hz / 115,200bps * 1 = 434.0278  434:115,207.37bps
			COMM_RX_SPEED_HALF	=>	conv_std_logic_vector(217,9)	-- 50,000,000Hz / 115,200bps / 2 = 217.0138  217:115,207.37bps
		)
		port map(
			srst				=>	srst			,
			clk					=>	clk				,
			
			busy				=>	rx_busy			,
			pdatmax				=>	pdatmax			,
			
			sdat				=>	sdat			,
			
			pdat_parity_error	=>	rx_pdat_parity_error,
			pdat_chksum_error	=>	rx_pdat_chksum_error,
			pdat_valid			=>	rx_pdat_valid	,
			
			pdat_chksum			=>	rx_pdat_chksum	,
			pdat00				=>	rx_pdat00		,
			pdat01				=>	rx_pdat01		,
			pdat02				=>	rx_pdat02		,
			pdat03				=>	rx_pdat03		,
			pdat04				=>	rx_pdat04		,
			pdat05				=>	rx_pdat05		,
			pdat06				=>	rx_pdat06		,
			pdat07				=>	rx_pdat07		,
			pdat08				=>	rx_pdat08		,
			pdat09				=>	rx_pdat09		,
			pdat10				=>	rx_pdat10		,
			pdat11				=>	rx_pdat11		,
			pdat12				=>	rx_pdat12		,
			pdat13				=>	rx_pdat13		,
			pdat14				=>	rx_pdat14		,
			pdat15				=>	rx_pdat15		,
			pdat16				=>	rx_pdat16		,
			pdat17				=>	rx_pdat17		,
			pdat18				=>	rx_pdat18		,
			pdat19				=>	rx_pdat19		,
			pdat20				=>	rx_pdat20		,
			pdat21				=>	rx_pdat21		,
			pdat22				=>	rx_pdat22		,
			pdat23				=>	rx_pdat23		,
			pdat24				=>	rx_pdat24		,
			pdat25				=>	rx_pdat25		,
			pdat26				=>	rx_pdat26		,
			pdat27				=>	rx_pdat27		,
			pdat28				=>	rx_pdat28		,
			pdat29				=>	rx_pdat29		,
			pdat30				=>	rx_pdat30		,
			pdat31				=>	rx_pdat31		
		);
	
	
	clkGen: process
	begin
	    clk <= '0';
	    wait for 20 ns;
	    clk <= '1';
	    wait for 20 ns;
	end process;
	
	
	--
	StimGen: process
		--variable L : LINE;
	begin
		srst <= 'X';
		wait until rising_edge(clk);
		wait until rising_edge(clk);
		wait until rising_edge(clk);
		srst <= '0';
		wait until rising_edge(clk);
		srst <= '1';
		wait until rising_edge(clk);
		srst <= '0';
		wait until rising_edge(clk);
		wait until rising_edge(clk);
		wait until rising_edge(clk);
		
		pdat00	<=	X"90";
		pdat01	<=	X"91";
		pdat02	<=	X"92";
		pdat03	<=	X"93";
		pdat04	<=	X"94";
		pdat05	<=	X"95";
		pdat06	<=	X"96";
		pdat07	<=	X"97";
		pdat08	<=	X"98";
		pdat09	<=	X"99";
		pdat10	<=	X"9A";
		pdat11	<=	X"9B";
		pdat12	<=	X"9C";
		pdat13	<=	X"9D";
		pdat14	<=	X"9E";
		pdat15	<=	X"9F";
		
		start	<=	'1';
		wait until rising_edge(clk);
		start	<=	'0';
		wait until rising_edge(clk);
		wait until falling_edge(busy);
		wait until rising_edge(clk);
		
		for I in 1 to 1000 loop
			wait until rising_edge(clk);
		end loop;
		
		stop;
		wait;
		
	end process;
	
	
end sim;
